//---------------------------------------------------------------------------
#ifndef CustomCardH
#define CustomCardH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
enum TCardSuit { Clubs, Diamonds, Hearts, Spades };
enum TCardBack { Apple, Balloon, Butterfly, Chip, Clover, Compass, Darts, Diamond, Icecream, Puzzle, Rose, Star, YingYang, cPrizeCup, O, X};
enum TCardValue {Ace, Two, Three, Four, Five, Six, Seven, Eight, Nine, Ten, Jack, Queen, King};

class PACKAGE TCustomCard : public TCustomControl
{
private:
  bool FTurn;
  bool FShowFace;
  int FPlayer;
  AnsiString FCard;
  TCardBack FBack;
  TCardSuit FCardSuit;
  TCardValue FCardValue;

protected:
  virtual void __fastcall Paint(void);
  virtual void __fastcall SetCard(AnsiString ACard);
  virtual void __fastcall SetBack(TCardBack ABack);
  virtual void __fastcall SetCardSuit(TCardSuit ASuit);
  virtual void __fastcall SetCardValue(TCardValue AValue);
  virtual void __fastcall FlipCard(bool ADisplayFace);

public:
	__fastcall TCustomCard(TComponent* Owner);
  __property AnsiString Card={read=FCard,write=SetCard};
__published:
  __property int Player={read=FPlayer,write=FPlayer};
  __property TCardBack CardBack={read=FBack,write=SetBack};
  __property TCardSuit CardSuit={read=FCardSuit,write=SetCardSuit};
  __property TCardValue CardValue={read=FCardValue,write=SetCardValue};
  __property bool Turn={read= FTurn, write=FTurn};
  __property bool ShowFace={read= FShowFace, write=FlipCard};
  __property OnClick;
  __property OnDragDrop;
  __property OnDragOver;
  __property OnEndDrag;
  __property OnDblClick;
};
//---------------------------------------------------------------------------
#endif
 